#ifndef MEM_H
#define MEM_H  /* block for forever(or nest) loop */


#define MALLOC(x)   malloc(x)
#define FREE(x)     free(x)


#ifdef USE_MLOCK

#define MLOCK(addr, len)    mlock((void*)addr, len)

#define XMLOCK(addr, len)   { \
        if(mlock((void*)addr, len)<0) { \
            Trace("fail mlock(%p,%d) (%d)\n", (char*)addr, len, errno); \
        } \
        else { \
        } \
    }

#ifdef MALLOC
#undef MALLOC
#endif
#define MALLOC(len) kotetu_mem_alloc_lock(len)

#else

#define MLOCK(addr, len)        /* nothing */

#endif

void* kotetu_mem_alloc_lock(int);

#endif /* MEM_H*/

